import{s as ya,f as st,n as ba,o as xa}from"../chunks/scheduler.37c15a92.js";import{S as _a,i as Ma,g as i,s as n,r as ct,m as r,H as g,A as Ta,h as p,f as s,c as l,j as w,u as ht,x as o,n as c,B as u,k as h,y as m,a as e,v as gt,d as ut,t as dt,w as ft}from"../chunks/index.7cb9c9b8.js";import{H as vt}from"../chunks/Heading.d3928e2a.js";function ka(Rs){let y,wt,mt,yt,P,bt,C,xt,L,Ss="Let’s remember what the objective is to optimize in Reinforce:",_t,j,Es,Mt,$,Gs="The idea was that by taking a gradient ascent step on this function (equivalent to taking gradient descent of the negative of this function), we would <strong>push our agent to take actions that lead to higher rewards and avoid harmful actions.</strong>",Tt,z,qs="However, the problem comes from the step size:",kt,H,Fs="<li>Too small, <strong>the training process was too slow</strong></li> <li>Too high, <strong>there was too much variability in the training</strong></li>",Pt,O,As="With PPO, the idea is to constrain our policy update with a new objective function called the <em>Clipped surrogate objective function</em> that <strong>will constrain the policy change in a small range using a clip.</strong>",Ct,I,Us="This new function <strong>is designed to avoid destructively large weights updates</strong> :",Lt,R,Bs,jt,S,Ws="Let’s study each part to understand how it works.",$t,E,zt,G,Ns,Ht,q,Ks="This ratio is calculated as follows:",Ot,F,Ds,It,d,Ps,Rt,ma='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>a</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> a_t </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',St,Et,ra='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>s</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> s_t </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Gt,qt,_,Cs,Ft,oa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> r_t(\\theta) </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',At,Ut,M,T,Ls,Bt,ca='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo><mo>&gt;</mo><mn>1</mn></mrow><annotation encoding="application/x-tex"> r_t(\\theta) &gt; 1 </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">&gt;</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">1</span></span></span></span>',Wt,b,js,Nt,ha='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>a</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> a_t </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">a</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Kt,Dt,ga='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>s</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> s_t </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.5806em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">s</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Jt,$s,x,zs,Qt,ua='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> r_t(\\theta) </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',Vt,at,Js="action is less likely for the current policy than for the old one",Hs,Xt,A,Qs="So this probability ratio is an <strong>easy way to estimate the divergence between old and current policy.</strong>",Yt,U,Zt,B,Vs,ts,W,Xs="This ratio <strong>can replace the log probability we use in the policy objective function</strong>. This gives us the left part of the new objective function: multiplying the ratio by the advantage.",ss,k,Ys='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/unclipped2.jpg" alt="PPO"/> <figcaption><a href="https://arxiv.org/pdf/1707.06347.pdf">Proximal Policy Optimization Algorithms</a></figcaption>',as,N,Zs="However, without a constraint, if the action taken is much more probable in our current policy than in our former, <strong>this would lead to a significant policy gradient step</strong> and, therefore, an <strong>excessive policy update.</strong>",es,K,ns,D,ta,ls,J,sa="Consequently, we need to constrain this objective function by penalizing changes that lead to a ratio far away from 1 (in the paper, the ratio can only vary from 0.8 to 1.2).",is,Q,aa="<strong>By clipping the ratio, we ensure that we do not have a too large policy update because the current policy can’t be too different from the older one.</strong>",ps,V,ea="To do that, we have two solutions:",ms,X,na="<li><em>TRPO (Trust Region Policy Optimization)</em> uses KL divergence constraints outside the objective function to constrain the policy update. But this method <strong>is complicated to implement and takes more computation time.</strong></li> <li><em>PPO</em> clip probability ratio directly in the objective function with its <strong>Clipped surrogate objective function.</strong></li>",rs,Y,la,os,f,Os,cs,da='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex"> r_t(\\theta) </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span></span></span></span>',hs,gs,fa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',us,ds,v,Is,fs,va='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',vs,ws,wa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>ϵ</mi><mo>=</mo><mn>0.2</mn></mrow><annotation encoding="application/x-tex"> \\epsilon = 0.2 </annotation></semantics></math></span><span class="katex-html hidden" aria-hidden="true"><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">ϵ</span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">0.2</span></span></span></span>',ys,bs,Z,ia="Then, we take the minimum of the clipped and non-clipped objective, <strong>so the final objective is a lower bound (pessimistic bound) of the unclipped objective.</strong>",xs,tt,pa="Taking the minimum of the clipped and non-clipped objective means <strong>we’ll select either the clipped or the non-clipped objective based on the ratio and advantage situation</strong>.",_s,rt,Ms;return P=new vt({props:{title:"Introducing the Clipped Surrogate Objective Function",local:"introducing-the-clipped-surrogate-objective-function",headingTag:"h1"}}),C=new vt({props:{title:"Recap: The Policy Objective Function",local:"recap-the-policy-objective-function",headingTag:"h2"}}),E=new vt({props:{title:"The Ratio Function",local:"the-ratio-function",headingTag:"h2"}}),U=new vt({props:{title:"The unclipped part of the Clipped Surrogate Objective function",local:"the-unclipped-part-of-the-clipped-surrogate-objective-function",headingTag:"h2"}}),K=new vt({props:{title:"The clipped Part of the Clipped Surrogate Objective function",local:"the-clipped-part-of-the-clipped-surrogate-objective-function",headingTag:"h2"}}),{c(){y=i("meta"),wt=n(),mt=i("p"),yt=n(),ct(P.$$.fragment),bt=n(),ct(C.$$.fragment),xt=n(),L=i("p"),L.textContent=Ss,_t=n(),j=i("img"),Mt=n(),$=i("p"),$.innerHTML=Gs,Tt=n(),z=i("p"),z.textContent=qs,kt=n(),H=i("ul"),H.innerHTML=Fs,Pt=n(),O=i("p"),O.innerHTML=As,Ct=n(),I=i("p"),I.innerHTML=Us,Lt=n(),R=i("img"),jt=n(),S=i("p"),S.textContent=Ws,$t=n(),ct(E.$$.fragment),zt=n(),G=i("img"),Ht=n(),q=i("p"),q.textContent=Ks,Ot=n(),F=i("img"),It=n(),d=i("p"),Ps=r("It’s the probability of taking action "),Rt=new g(!1),St=r(" at state "),Et=new g(!1),Gt=r(" in the current policy, divided by the same for the previous policy."),qt=n(),_=i("p"),Cs=r("As we can see, "),Ft=new g(!1),At=r(" denotes the probability ratio between the current and old policy:"),Ut=n(),M=i("ul"),T=i("li"),Ls=r("If "),Bt=new g(!1),Wt=r(", the "),b=i("strong"),js=r("action "),Nt=new g(!1),Kt=r(" at state "),Dt=new g(!1),Jt=r(" is more likely in the current policy than the old policy."),$s=n(),x=i("li"),zs=r("If "),Qt=new g(!1),Vt=r(" is between 0 and 1, the "),at=i("strong"),at.textContent=Js,Hs=r("."),Xt=n(),A=i("p"),A.innerHTML=Qs,Yt=n(),ct(U.$$.fragment),Zt=n(),B=i("img"),ts=n(),W=i("p"),W.innerHTML=Xs,ss=n(),k=i("figure"),k.innerHTML=Ys,as=n(),N=i("p"),N.innerHTML=Zs,es=n(),ct(K.$$.fragment),ns=n(),D=i("img"),ls=n(),J=i("p"),J.textContent=sa,is=n(),Q=i("p"),Q.innerHTML=aa,ps=n(),V=i("p"),V.textContent=ea,ms=n(),X=i("ul"),X.innerHTML=na,rs=n(),Y=i("img"),os=n(),f=i("p"),Os=r("This clipped part is a version where "),cs=new g(!1),hs=r(" is clipped between  "),gs=new g(!1),us=r("."),ds=n(),v=i("p"),Is=r("With the Clipped Surrogate Objective function, we have two probability ratios, one non-clipped and one clipped in a range between  "),fs=new g(!1),vs=r(", epsilon is a hyperparameter that helps us to define this clip range (in the paper  "),ws=new g(!1),ys=r(".)."),bs=n(),Z=i("p"),Z.innerHTML=ia,xs=n(),tt=i("p"),tt.innerHTML=pa,_s=n(),rt=i("p"),this.h()},l(t){const a=Ta("svelte-u9bgzb",document.head);y=p(a,"META",{name:!0,content:!0}),a.forEach(s),wt=l(t),mt=p(t,"P",{}),w(mt).forEach(s),yt=l(t),ht(P.$$.fragment,t),bt=l(t),ht(C.$$.fragment,t),xt=l(t),L=p(t,"P",{"data-svelte-h":!0}),o(L)!=="svelte-1jx0086"&&(L.textContent=Ss),_t=l(t),j=p(t,"IMG",{src:!0,alt:!0}),Mt=l(t),$=p(t,"P",{"data-svelte-h":!0}),o($)!=="svelte-1wz1mni"&&($.innerHTML=Gs),Tt=l(t),z=p(t,"P",{"data-svelte-h":!0}),o(z)!=="svelte-70fob"&&(z.textContent=qs),kt=l(t),H=p(t,"UL",{"data-svelte-h":!0}),o(H)!=="svelte-9oh9id"&&(H.innerHTML=Fs),Pt=l(t),O=p(t,"P",{"data-svelte-h":!0}),o(O)!=="svelte-mlpukg"&&(O.innerHTML=As),Ct=l(t),I=p(t,"P",{"data-svelte-h":!0}),o(I)!=="svelte-1tgcet3"&&(I.innerHTML=Us),Lt=l(t),R=p(t,"IMG",{src:!0,alt:!0}),jt=l(t),S=p(t,"P",{"data-svelte-h":!0}),o(S)!=="svelte-pc0b8m"&&(S.textContent=Ws),$t=l(t),ht(E.$$.fragment,t),zt=l(t),G=p(t,"IMG",{src:!0,alt:!0}),Ht=l(t),q=p(t,"P",{"data-svelte-h":!0}),o(q)!=="svelte-1sbo9d1"&&(q.textContent=Ks),Ot=l(t),F=p(t,"IMG",{src:!0,alt:!0}),It=l(t),d=p(t,"P",{});var et=w(d);Ps=c(et,"It’s the probability of taking action "),Rt=u(et,!1),St=c(et," at state "),Et=u(et,!1),Gt=c(et," in the current policy, divided by the same for the previous policy."),et.forEach(s),qt=l(t),_=p(t,"P",{});var Ts=w(_);Cs=c(Ts,"As we can see, "),Ft=u(Ts,!1),At=c(Ts," denotes the probability ratio between the current and old policy:"),Ts.forEach(s),Ut=l(t),M=p(t,"UL",{});var ks=w(M);T=p(ks,"LI",{});var ot=w(T);Ls=c(ot,"If "),Bt=u(ot,!1),Wt=c(ot,", the "),b=p(ot,"STRONG",{});var nt=w(b);js=c(nt,"action "),Nt=u(nt,!1),Kt=c(nt," at state "),Dt=u(nt,!1),Jt=c(nt," is more likely in the current policy than the old policy."),nt.forEach(s),ot.forEach(s),$s=l(ks),x=p(ks,"LI",{});var lt=w(x);zs=c(lt,"If "),Qt=u(lt,!1),Vt=c(lt," is between 0 and 1, the "),at=p(lt,"STRONG",{"data-svelte-h":!0}),o(at)!=="svelte-sxr5di"&&(at.textContent=Js),Hs=c(lt,"."),lt.forEach(s),ks.forEach(s),Xt=l(t),A=p(t,"P",{"data-svelte-h":!0}),o(A)!=="svelte-m31yz6"&&(A.innerHTML=Qs),Yt=l(t),ht(U.$$.fragment,t),Zt=l(t),B=p(t,"IMG",{src:!0,alt:!0}),ts=l(t),W=p(t,"P",{"data-svelte-h":!0}),o(W)!=="svelte-zxswmp"&&(W.innerHTML=Xs),ss=l(t),k=p(t,"FIGURE",{class:!0,"data-svelte-h":!0}),o(k)!=="svelte-13ku1ey"&&(k.innerHTML=Ys),as=l(t),N=p(t,"P",{"data-svelte-h":!0}),o(N)!=="svelte-1e78bt7"&&(N.innerHTML=Zs),es=l(t),ht(K.$$.fragment,t),ns=l(t),D=p(t,"IMG",{src:!0,alt:!0}),ls=l(t),J=p(t,"P",{"data-svelte-h":!0}),o(J)!=="svelte-cpftrh"&&(J.textContent=sa),is=l(t),Q=p(t,"P",{"data-svelte-h":!0}),o(Q)!=="svelte-1iqqwcw"&&(Q.innerHTML=aa),ps=l(t),V=p(t,"P",{"data-svelte-h":!0}),o(V)!=="svelte-aufndz"&&(V.textContent=ea),ms=l(t),X=p(t,"UL",{"data-svelte-h":!0}),o(X)!=="svelte-5n19r6"&&(X.innerHTML=na),rs=l(t),Y=p(t,"IMG",{src:!0,alt:!0}),os=l(t),f=p(t,"P",{});var it=w(f);Os=c(it,"This clipped part is a version where "),cs=u(it,!1),hs=c(it," is clipped between  "),gs=u(it,!1),us=c(it,"."),it.forEach(s),ds=l(t),v=p(t,"P",{});var pt=w(v);Is=c(pt,"With the Clipped Surrogate Objective function, we have two probability ratios, one non-clipped and one clipped in a range between  "),fs=u(pt,!1),vs=c(pt,", epsilon is a hyperparameter that helps us to define this clip range (in the paper  "),ws=u(pt,!1),ys=c(pt,".)."),pt.forEach(s),bs=l(t),Z=p(t,"P",{"data-svelte-h":!0}),o(Z)!=="svelte-eqkgrh"&&(Z.innerHTML=ia),xs=l(t),tt=p(t,"P",{"data-svelte-h":!0}),o(tt)!=="svelte-1k9oa10"&&(tt.innerHTML=pa),_s=l(t),rt=p(t,"P",{}),w(rt).forEach(s),this.h()},h(){h(y,"name","hf:doc:metadata"),h(y,"content",Pa),st(j.src,Es="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/lpg.jpg")||h(j,"src",Es),h(j,"alt","Reinforce"),st(R.src,Bs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ppo-surrogate.jpg")||h(R,"src",Bs),h(R,"alt","PPO surrogate function"),st(G.src,Ns="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ratio1.jpg")||h(G,"src",Ns),h(G,"alt","Ratio"),st(F.src,Ds="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ratio2.jpg")||h(F,"src",Ds),h(F,"alt","Ratio"),Rt.a=St,Et.a=Gt,Ft.a=At,Bt.a=Wt,Nt.a=Kt,Dt.a=Jt,Qt.a=Vt,st(B.src,Vs="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/unclipped1.jpg")||h(B,"src",Vs),h(B,"alt","PPO"),h(k,"class","image table text-center m-0 w-full"),st(D.src,ta="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/clipped.jpg")||h(D,"src",ta),h(D,"alt","PPO"),st(Y.src,la="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/clipped.jpg")||h(Y,"src",la),h(Y,"alt","PPO"),cs.a=hs,gs.a=us,fs.a=vs,ws.a=ys},m(t,a){m(document.head,y),e(t,wt,a),e(t,mt,a),e(t,yt,a),gt(P,t,a),e(t,bt,a),gt(C,t,a),e(t,xt,a),e(t,L,a),e(t,_t,a),e(t,j,a),e(t,Mt,a),e(t,$,a),e(t,Tt,a),e(t,z,a),e(t,kt,a),e(t,H,a),e(t,Pt,a),e(t,O,a),e(t,Ct,a),e(t,I,a),e(t,Lt,a),e(t,R,a),e(t,jt,a),e(t,S,a),e(t,$t,a),gt(E,t,a),e(t,zt,a),e(t,G,a),e(t,Ht,a),e(t,q,a),e(t,Ot,a),e(t,F,a),e(t,It,a),e(t,d,a),m(d,Ps),Rt.m(ma,d),m(d,St),Et.m(ra,d),m(d,Gt),e(t,qt,a),e(t,_,a),m(_,Cs),Ft.m(oa,_),m(_,At),e(t,Ut,a),e(t,M,a),m(M,T),m(T,Ls),Bt.m(ca,T),m(T,Wt),m(T,b),m(b,js),Nt.m(ha,b),m(b,Kt),Dt.m(ga,b),m(b,Jt),m(M,$s),m(M,x),m(x,zs),Qt.m(ua,x),m(x,Vt),m(x,at),m(x,Hs),e(t,Xt,a),e(t,A,a),e(t,Yt,a),gt(U,t,a),e(t,Zt,a),e(t,B,a),e(t,ts,a),e(t,W,a),e(t,ss,a),e(t,k,a),e(t,as,a),e(t,N,a),e(t,es,a),gt(K,t,a),e(t,ns,a),e(t,D,a),e(t,ls,a),e(t,J,a),e(t,is,a),e(t,Q,a),e(t,ps,a),e(t,V,a),e(t,ms,a),e(t,X,a),e(t,rs,a),e(t,Y,a),e(t,os,a),e(t,f,a),m(f,Os),cs.m(da,f),m(f,hs),gs.m(fa,f),m(f,us),e(t,ds,a),e(t,v,a),m(v,Is),fs.m(va,v),m(v,vs),ws.m(wa,v),m(v,ys),e(t,bs,a),e(t,Z,a),e(t,xs,a),e(t,tt,a),e(t,_s,a),e(t,rt,a),Ms=!0},p:ba,i(t){Ms||(ut(P.$$.fragment,t),ut(C.$$.fragment,t),ut(E.$$.fragment,t),ut(U.$$.fragment,t),ut(K.$$.fragment,t),Ms=!0)},o(t){dt(P.$$.fragment,t),dt(C.$$.fragment,t),dt(E.$$.fragment,t),dt(U.$$.fragment,t),dt(K.$$.fragment,t),Ms=!1},d(t){t&&(s(wt),s(mt),s(yt),s(bt),s(xt),s(L),s(_t),s(j),s(Mt),s($),s(Tt),s(z),s(kt),s(H),s(Pt),s(O),s(Ct),s(I),s(Lt),s(R),s(jt),s(S),s($t),s(zt),s(G),s(Ht),s(q),s(Ot),s(F),s(It),s(d),s(qt),s(_),s(Ut),s(M),s(Xt),s(A),s(Yt),s(Zt),s(B),s(ts),s(W),s(ss),s(k),s(as),s(N),s(es),s(ns),s(D),s(ls),s(J),s(is),s(Q),s(ps),s(V),s(ms),s(X),s(rs),s(Y),s(os),s(f),s(ds),s(v),s(bs),s(Z),s(xs),s(tt),s(_s),s(rt)),s(y),ft(P,t),ft(C,t),ft(E,t),ft(U,t),ft(K,t)}}}const Pa='{"title":"Introducing the Clipped Surrogate Objective Function","local":"introducing-the-clipped-surrogate-objective-function","sections":[{"title":"Recap: The Policy Objective Function","local":"recap-the-policy-objective-function","sections":[],"depth":2},{"title":"The Ratio Function","local":"the-ratio-function","sections":[],"depth":2},{"title":"The unclipped part of the Clipped Surrogate Objective function","local":"the-unclipped-part-of-the-clipped-surrogate-objective-function","sections":[],"depth":2},{"title":"The clipped Part of the Clipped Surrogate Objective function","local":"the-clipped-part-of-the-clipped-surrogate-objective-function","sections":[],"depth":2}],"depth":1}';function Ca(Rs){return xa(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class za extends _a{constructor(y){super(),Ma(this,y,Ca,ka,ya,{})}}export{za as component};
